diff --git a/bin/varnishd/cache/cache_ban_build.c b/bin/varnishd/cache/cache_ban_build.c
index 28376f56c2..ad6ddc5efe 100644
--- a/bin/varnishd/cache/cache_ban_build.c
+++ b/bin/varnishd/cache/cache_ban_build.c
@@ -246,7 +246,8 @@ BAN_AddTest(struct ban_proto *bp,
 		return (bp->err);
 
 	for (pv = pvars; pv->name != NULL; pv++)
-		if (!strncmp(a1, pv->name, strlen(pv->name)))
+		if ((!(pv->flag & BANS_FLAG_HTTP) && !strcmp(a1, pv->name))
+			|| (pv->flag & BANS_FLAG_HTTP && !strncmp(a1, pv->name, strlen(pv->name))))
 			break;
 
 	if (pv->name == NULL)
